



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Asp.net数据库缓存依赖</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Asp.net数据库缓存依赖</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 20:34:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2><a href="http://www.cnblogs.com/lgxlsm/archive/2012/11/04/2753969.html" rel="external nofollow noreferrer">Asp.net数据库缓存依赖</a></h2>
<div>
<div>
<p>　　更多的时候，我们的服务器性能损耗还是在查询数据库的时候，所以对数据库的缓存还是显得特别重要，上面几种方式都可以实现部分数据缓存功能。但问题是我们的数据有时候是在变化的，这样用户可能在缓存期间查询的数据就是老的数据，从而导致数据的不一致。那有没有办法做到，数据如果不变化，用户就一直从缓存中取数据，一旦数据变化，系统能自动更新缓存中的数据，从而让用户得到更好的用户体验。</p>
<p>　　答案是肯定的！.NET已经为我们提供了这样一种非常好的解决方法：SqlCacheDependency数据库缓存依赖。</p>
<p>　　实现步骤：</p>
<p>　　下面就让我们看一下如何实现数据库缓存依赖功能：</p>
<p>　　第一步： 修改web.config，让项目启用SqlCacheDependency 。</p>
<p>　　将下列代码加入web.config的&lt;system.web&gt;节：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">&lt;?xml version="1.0"?&gt;<br />
&lt;!--<br />
  有关如何配置 ASP.NET 应用程序的详细信息，请访问<br />
  http://go.microsoft.com/fwlink/?LinkId=169433<br />
  --&gt;<br />
&lt;configuration&gt;<br />
    &lt;system.web&gt;

        &lt;caching&gt;<br />
            &lt;sqlCacheDependency enabled="true" pollTime="6000"&gt;<br />
                &lt;databases&gt;<br />
                    &lt;add name="codematic" connectionStringName="strcodematic" /&gt;<br />
                &lt;/databases&gt;<br />
            &lt;/sqlCacheDependency&gt;<br />
        &lt;/caching&gt;<br />
    &lt;/system.web&gt;<br />
    &lt;connectionStrings&gt;<br />
        &lt;add  name="strcodematic" connectionString="server=.;database=XLinShaWyDBase;uid=sa;pwd=123"/&gt;<br />
    &lt;/connectionStrings&gt;<br />
&lt;/configuration&gt;</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>　　这里的connectionStringName指定了在&lt;connectionStrings&gt;中添加的某一个连接字符串。name则是为该SqlCacheDependency起的名字，这个名字将在第3步中用到。<br />　　SqlCacheDependency类会自动完成对此配置节信息的读取以建立和数据库之间的联系。</p>
<p>　　<strong>注意：</strong>在&lt;databases&gt;节的&lt;add name="codematic" connectionStringName="strcodematic"/&gt;中的name属性值必须和第三步的Page_Load代码中System.Web.Caching.SqlCacheDependency("codematic","dbo.Contact"); 中的第一个参数（数据库名称）相一致。<br />　　第二步：执行下述命令，为 数据库启用缓存依赖。</p>
<p>　　如果要配置SqlCacheDependency，则需要以命令行的方式执行。</p>
<p>　　aspnet_regsql.exe工具位于Windows\\Microsoft.NET\\Framework\\[版本]文件夹中。</p>
<p>　　如：(C:\WINDOWS\Microsoft.NET\Framework\v4.0.30319)</p>
<p>　　aspnet_regsql -C "data source=.;initial catalog=XLinShaWyDBase;user id=sa;password=123" -ed -et -t "dbo.Contact"</p>
<p>　　参数-C后面的字符串是连接字符串（请替换成自己所需要的值），</p>
<p>　　参数-t后面的字符串是数据表的名字。</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/411991/2012110417075365.png" /></p>
<p>生产成功后，在对应的数据库，会多一个表dbo.AspNet_SqlCacheTablesForChangeNotification</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/411991/2012110417102056.png" /></p>
<p>select * from dbo.AspNet_SqlCacheTablesForChangeNotification</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/411991/2012110417120328.png" /></p>
<p>　<strong>注意：</strong></p>
<p>　　要使得7.0或者2000版本以上的SQLServer支持SqlCacheDependency特性，需要对数据库服务器执行相关的配置。</p>
<p>　　有两种方法配置SQLServer：</p>
<p>　　一使用aspnet_regsql命令行工具，</p>
<p>　　二使用SqlCacheDependencyAdmin类。</p>
<p>　　例如：</p>
<p>　　aspnet_regsql -S "server"-E -d "database"&ndash;ed &nbsp;或者</p>
<p>　　aspnet_regsql -S "server"-E -d "database"-et -t "table"<br />　　如果是Sql验证的话要把-E换成，-U (用户名),-P (密码)</p>
<p>　　以下是该工具的命令参数说明：</p>
<p>　　-? 显示该工具的帮助功能；</p>
<p>　　-S 后接的参数为数据库服务器的名称或者IP地址；</p>
<p>　　-U 后接的参数为数据库的登陆用户名；</p>
<p>　　-P 后接的参数为数据库的登陆密码；</p>
<p>　　-E 使用当前登录用户的 Windows 集成认证进行身份验证。</p>
<p>　　-d 后接参数为对哪一个数据库采用SqlCacheDependency功能；</p>
<p>　　-C 连接数据库的连接字符串。如果您指定服务器(-S)和登录（-U和-P，或 -E）信息，则此选项不是必需的，因为连接字符串已经包含这些信息。</p>
<p>　　-t 后接参数为对哪一个表采用SqlCacheDependency功能；</p>
<p>　　-ed 允许对数据库使用SqlCacheDependency功能；</p>
<p>　　-dd 禁止对数据库采用SqlCacheDependency功能；</p>
<p>　　-et 允许对数据表采用SqlCacheDependency功能；</p>
<p>　　-dt 禁止对数据表采用SqlCacheDependency功能；</p>
<p>　　-lt 列出当前数据库中有哪些表已经采用sqlcachedependency功能。</p>
<p>　　第三步：在代码中使用缓存，并为其设置SqlCacheDependency依赖：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">using System;<br />
using System.Collections.Generic;<br />
using System.Linq;<br />
using System.Web;<br />
using System.Web.UI;<br />
using System.Web.UI.WebControls;<br />
using System.Data.SqlClient;<br />
using System.Data;

public partial class Default4 : System.Web.UI.Page<br />
{<br />
    /// &lt;summary&gt;<br />
    /// 获取当前应用程序指定CacheKey的Cache对象值<br />
    /// &lt;/summary&gt;<br />
    /// &lt;param name="CacheKey"&gt;索引键值&lt;/param&gt;<br />
    /// &lt;returns&gt;返回缓存对象&lt;/returns&gt;<br />
    public static object GetCache(string CacheKey)<br />
    {<br />
        System.Web.Caching.Cache objCache = HttpRuntime.Cache;<br />
        return objCache[CacheKey];<br />
    }

    /// &lt;summary&gt;<br />
    /// 设置以缓存依赖的方式缓存数据<br />
    /// &lt;/summary&gt;<br />
    /// &lt;param name="CacheKey"&gt;索引键值&lt;/param&gt;<br />
    /// &lt;param name="objObject"&gt;缓存对象&lt;/param&gt;<br />
    /// &lt;param name="cacheDepen"&gt;依赖对象&lt;/param&gt;<br />
    public static void SetCache(string CacheKey, object objObject, System.Web.Caching.CacheDependency dep)<br />
    {<br />
        System.Web.Caching.Cache objCache = HttpRuntime.Cache;<br />
        objCache.Insert(<br />
            CacheKey,<br />
            objObject,<br />
            dep,<br />
            System.Web.Caching.Cache.NoAbsoluteExpiration, //从不过期<br />
            System.Web.Caching.Cache.NoSlidingExpiration, //禁用可调过期<br />
            System.Web.Caching.CacheItemPriority.Default,<br />
            null);<br />
    }<br />
    protected void Page_Load(object sender, EventArgs e)<br />
    {<br />
        string CacheKey = "cachetest";<br />
        object objModel = GetCache(CacheKey);//从缓存中获取<br />
        if (objModel == null)//缓存里没有<br />
        {<br />
            objModel = GetData();//把当前时间进行缓存<br />
            if (objModel != null)<br />
            {<br />
                //依赖数据库codematic中的P_Product表变化 来更新缓存<br />
                System.Web.Caching.SqlCacheDependency dep = new System.Web.Caching.SqlCacheDependency("codematic", "dbo.Contact");<br />
                SetCache(CacheKey, objModel, dep);//写入缓存<br />
            }<br />
        }<br />
        GridView1.DataSource = (DataSet)objModel;<br />
        GridView1.DataBind();<br />
    }<br />
    private DataSet GetData()<br />
    {<br />
        string conString = "data source=.;initial catalog=XLinShaWyDBase;user id=sa;password=123"; string strSQL = "SELECT * FROM dbo.Contact";<br />
        SqlConnection myConnection = new SqlConnection(conString);<br />
        DataSet ds = new DataSet(); myConnection.Open();<br />
        SqlDataAdapter adapter = new SqlDataAdapter(strSQL, myConnection); adapter.Fill(ds, "dbo.Contact");<br />
        myConnection.Close();<br />
        return ds;<br />
    }

}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>从以上代码可以看出，和文件依赖基本相同，只是在存放缓存SetCache时存入的依赖对象不同罢了。这里用的是SqlCacheDependency。</p>
<p>　　其中，创建SqlCacheDependency的构造方法：</p>
<p>　　public SqlCacheDependency(string databaseEntryName,string tableName)</p>
<p>　　databaseEntryName ：是在Web.config 文件的 caching 节的 sqlCacheDependency 的 databases 元素中定义的数据库的名称。</p>
<p>　　tableName ：与 SqlCacheDependency 关联的数据库表的名称。</p>
<p>　　这样，只有当dbo.Contact表的内容发生变化时，查询操作才会重新查询数据更新缓存的内容，可以大大减少数据库的重复查询和提高系统的性能和运行效率。</p>
</div>
<div>
<div>&nbsp;</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mwl36q.html">MATLAB plot 绘图的一些经验，记下来，facilitate future work</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1llz68.html">eclipse导入项目前面有感叹号</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qygk02q.html">setValuesForKeysWithDictionary 的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xdl0z9.html">C&num;判断当前操作系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm2m109.html">（转）Eclipse中junit框架的使用&mdash;&mdash;单元测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memvm2q.html">0x3f3f3f3f&period;&period;&period;编程中无穷大常量的设置技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mrj4n8.html">分享一个SQLSERVER脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/950mk468.html">负载均衡软件LVS分析二&lpar;安装&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyrrpj9.html">JavaNIO非阻塞模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljp3d19.html">如何基于 eolinker 的进行接口管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpydoxq.html">validatebox相关验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ogpz18.html">关于JVM内存的N个问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv171gq.html">PHP文件操作&lbrack;总结&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnvedgq.html">How to convert String to Date &ndash; Java</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k5p6vq.html">&lbrack;svc&rsqb;高并发场景 LVS DR &plus;KeepAlive高可用实现及ka的persistence&lowbar;timeout参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkk72v8.html">CI框架 -- 网页缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnx2d7q.html">&num;ifdef 和 &num;if defined的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8km1pr59.html">Eclipse上安装springsource-tool-suite</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g3j0zlq.html">ccf-201609-3  炉石传说</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e0xgjjq.html">set &period;net principle</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93xmngw9.html">全世界最详细的图形化VMware中linux环境下oracle安装（一）【weber出品必属精品】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjlgx79.html">GacLib使用方法（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv4kp1q.html">SurfaceFlinger</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x2n5e8.html">CoreData &lpar;四&rpar;备</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjlemd9.html">&lbrack;原创&rsqb;零基础R语言教程---第二课---R语言入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z10x039.html">android的微信签名</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z12e69.html">Is there a complete List of JVM exit codes</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydzxegq.html">HornetQ</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1x6j59.html">VS2010下测试程序性能瓶颈</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd3ydr8.html">jquery使用总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
